/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	FSTUFF.C	Macro style I/O for C	*/


long lseek();

/*	FOPEN		macro style of open	*/

char *fopen(name,mode)
	char *name,*mode; {
	int  fil;

	switch(*mode) {
		case 'r':	return (fil=open(name,2)) == -1 ? 0: fil;
		case 'w':	return (fil=creat(name)) == -1 ? 0: fil;
		case 'a':	if ((fil=open(name,2)) != -1) {
						lseek(fil,0l,2);
						return fil;
						}
					return (fil=creat(name)) == -1 ? 0: fil;
		default:	return 0;
		}
	}



/*	FCLOSE			error = fclose(file number); */

fclose(filenum)
	int  filenum; {

	return close(filenum);
	}


/*	FREAD		  number read = fread(ptr, size, nitems, file); */

fread(ptr,size,nitems,filenum)
	char *ptr;
	unsigned size,nitems,filenum; {
	int nin;

	nin=read(filenum,ptr,nitems*size);
	return (nin== -1 || nin == 0) ? 0: nin/size;
	}



/*	FWRITE		number written = fwrite(ptr, size, nitems, file); */

fwrite(ptr,size,nitems,filenum)
	char *ptr;
	unsigned size,nitems,filenum; {

	return write(filenum,ptr,nitems*size) == -1 ? 0: nitems;
	}



/*	FSEEK		error = fseek(file, offset, type of seek);	*/

long fseek(filenum,offset,type)
	char *filenum;
	int  type;
	long offset; {

	return lseek(((int)filenum),offset,type);
	}


/*	REWIND		error = rewind(file);	*/

long rewind(filenum)
	int  filenum; {

	return lseek(filenum,0L,0);
	}

/*	LTELL  --	return current file location.	*/

long ltell(filenum)
	int filenum; {

	return lseek(filenum,0L,1);
	}





/*	FGETC		character = fgetc(file);	*/

fgetc(filenum)
	int  filenum; {

	return getc(filenum);
	}


/*	FPUTC		error = fputc(character, file);	*/

fputc(c,filenum)
	char c;
	int  filenum; {

	return putc(c,filenum);
	}
