/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	RENAME.C  --	RENAME A FILE	*/
/*	STANDARD FILE NUMBERS	*/

#define	STDIN	0
#define	STDOUT	1
#define	STDERR	2
#define STDPRN	4
#define FIRSTD	5

/*	CP/M	codes	*/

#define RENAME_CODE	23

#define UNUSED	0
#define	OPENI	1
#define OPENO	2
#define OPENU	3

#define	NFILE	8

#define FDRIVE	0
#define	FNAME	1
#define	FEXT	9
#define	FBLOCK	12
#define FSIZE	16
#define	FRECORD	32
#define	FLOC	33
#define FCBLEN	37
#define	FILELEN	176

struct { char mode, plusoff, dirty;
		unsigned bufnext, bufend, currec, numrec;
		char fcb[FCBLEN],fragment[128]; };

extern char _files[NFILE][FILELEN];
extern char _msdos2;

/*	RENAME			error code = rename(old name, new name);	*/

rename(old,new)
	char *old,*new; {
	int  oldnum,newnum;
	char *ofile,*nfile;

	if (_msdos2) return _rename(old,new);
	oldnum=_newfile(old);
	if (oldnum <= STDPRN) return -1;
	ofile=&_files[oldnum-FIRSTD][0];
	ofile->mode=OPENI;
	newnum=_newfile(new);
	if (newnum <= STDPRN) return -1;
	nfile=&_files[newnum-FIRSTD][0];
	ofile->mode=UNUSED;

	_move(16,nfile->fcb,(ofile->fcb)+16);
	if (_os(RENAME_CODE,ofile->fcb) == 255) return -1;
	return 0;
	}
