/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	STRDUP  --	use malloc to make a copy of a string.	*/

char *malloc();

char *strdup(str)
	char *str; {
	char *strat;

	strat=malloc(strlen(str)+1);
	if (strat) strcpy(strat,str);
	return strat;
	}



/*	STRLWR  --  make a string lower case	*/

char *strlwr(str)
	char *str; {
	char *strwas;

	strwas=str;
	while (*str) {
		if (*str >= 'A' && *str <= 'Z') *str+='a'-'A';
		str++;
		}
	return strwas;
	}


/*	STRUPR  --  make a string upper case	*/

char *strupr(str)
	char *str; {
	char *strwas;

	strwas=str;
	while (*str) {
		if (*str >= 'a' && *str <= 'z') *str-='a'-'A';
		str++;
		}
	return strwas;
	}



/*	STRREV  --	reverse a string.	*/

char *strrev(str)
	char *str; {
	int first,last;
	char ch;

	first=0;
	last=strlen(str)-1;
	while (first < last) {
		ch=str[last];
		str[last--]=str[first];
		str[first++]=ch;
		}
	return str;
	}



/*	STRSET  --	set the characters of a string */

char *strset(str,ch)
	char *str;
	char ch; {
	int i;

	i=0;
	i=strlen(str)-1;
	while (i >= 0) {
		str[i--]=ch;
		}
	return str;
	}



/*	STRTOK  --	return tokens from a string.
			    example:   char *tptr,*strtok();
	               tptr=strtok("   , aaa , bbb"," ,\t"); */

static char *_string,_token[40];

char *strpbrk();

char *strtok(str,toks)
	char *str,*toks; {
	int i;
	char *end;

	if (str) _string=str;
	else _string+=strlen(_token);
	_string+=strspn(_string,toks);
	if (*_string == 0) return 0;
	_move(40,_string,_token);
	end=strpbrk(_token,toks);
	if (end) *end=0;
	return _token;
	}
